#include <avr/io.h>
#include <stdint.h>
#include <util/delay.h>
#include <stdlib.h>
#include <avr/pgmspace.h>
#include "lcd.h"

/*
#define LED_PORT     PORTB
#define LED_GREEN    0
#define LED_RED      1
*/

void schlaf(float anz)
{
	for(int i = anz; i > 0; i -= 0.25)
	{
		_delay_ms(250);
	}
}

void main(void)
{
	int i, MenPkt;
	
	i 			= 0;
	MenPkt 		= 0;
	DDRA 		= 0xff;			//Port A als Ausgang definieren
	DDRB 		= 0xff;			//Port B als Ausgang definieren
	DDRD 		= 0x00;			//Port D als Eingang definieren
	
	PORTD 		= 0xff;			//enable pull-ups
	
	//PORTA 	= 0xFF;			//alles an Port A aus
	PORTB 		= 0x00;			//alle	LEDs/Relais aus
	PORTD 		= 0xFE;			//alles	an PORTD auf 0
	
	lcd_init(LCD_DISP_ON);
	schlaf(6);
	lcd_clrscr();
	lcd_command(LCD_DISP_ON_CURSOR);

	while(1)
	{
		if( (( PIND & ( 1 << PD2 ) ) == 0) && (MenPkt > 0) )		//Taster1 Menue reverse
		{
			MenPkt--;
			schlaf(1);
		}
		else if( (( PIND & ( 1 << PD2 ) ) == 0) && (MenPkt == 0) )	//Taster1 Menue reverse
		{
			MenPkt = 7;
			schlaf(1);
		}
		
		if( (( PIND & ( 1 << PD1 ) ) == 0) && (MenPkt < 7) )		//Taster2 Menue forward
		{
			MenPkt++;
			schlaf(1);
		}
		else if( (( PIND & ( 1 << PD1 ) ) == 0) && (MenPkt == 7) )//Taster2 Menue forward
		{
			MenPkt = 0;
			schlaf(1);
		}
		
		switch(MenPkt)
		{
			case 0:
				lcd_gotoxy(0,0);
				lcd_puts("LED_1 einschalten     ");
				lcd_gotoxy(0,1);
				lcd_puts("Eingabe mit Taster_3");
				if( ( PIND & ( 1 << PD0 ) ) == 0 )
				{
					PORTB |= ( 1 << PD1 );
				}
				break;
			
			case 1:
				lcd_gotoxy(0,0);
				lcd_puts("LED_2 einschalten     ");
				lcd_gotoxy(0,1);
				lcd_puts("Eingabe mit Taster_3");
				if( ( PIND & ( 1 << PD0 ) ) == 0 )	//Taster3 Menue Enter
				{
					PORTB |= ( 1 << PD2 );
				}
				break;
				
			case 2:
				lcd_gotoxy(0,0); 
				lcd_puts("LED_3 einschalten     ");
				lcd_gotoxy(0,1);
				lcd_puts("Eingabe mit Taster_3");
				if( ( PIND & ( 1 << PD0 ) ) == 0 )	//Taster3 Menue Enter
				{
					PORTB |= ( 1 << PD3 );
				}
				break;
			
			case 3:
				lcd_gotoxy(0,0);
				lcd_puts("LED_1 ausschalten     ");
				lcd_gotoxy(0,1);
				lcd_puts("Eingabe mit Taster_3");
				if( ( PIND & ( 1 << PD0 ) ) == 0 )	//Taster3 Menue Enter
				{
					PORTB &= 0xFD;			//LED (PORTB1)	aus
				}
				break;
			
			case 4:
				lcd_gotoxy(0,0);
				lcd_puts("LED_2 ausschalten     ");
				lcd_gotoxy(0,1);
				lcd_puts("Eingabe mit Taster_3");
				if( ( PIND & ( 1 << PD0 ) ) == 0 )	//Taster3 Menue Enter
				{
					PORTB &= 0xFB;			//LED (PORTB2)	aus
				}
				break;
			
			case 5:
				lcd_gotoxy(0,0); 
				lcd_puts("LED_3 ausschalten     ");
				lcd_gotoxy(0,1);
				lcd_puts("Eingabe mit Taster_3");
				if( ( PIND & ( 1 << PD0 ) ) == 0 )	//Taster3 Menue Enter
				{
					PORTB &= 0xF7;			//LED (PORTB3)	aus
				}
				break;
				
			case 6:
				lcd_gotoxy(0,0);
				lcd_puts("LED_1-3 einschalten   ");
				lcd_gotoxy(0,1);
				lcd_puts("Eingabe mit Taster_3");
				if( ( PIND & ( 1 << PD0 ) ) == 0 )	//Taster3 Menue Enter
				{
					PORTB |= 0x0E;	//LED (PORTB1-3) an
				}
				break;
				
			case 7:
				lcd_gotoxy(0,0);
				lcd_puts("LED_1-3 ausschalten   ");
				lcd_gotoxy(0,1);
				lcd_puts("Eingabe mit Taster_3");
				if( ( PIND & ( 1 << PD0 ) ) == 0 )	//Taster3 Menue Enter
				{
					PORTB &= 0x00;			//LED (PORTB1-3) aus
				}
				break;
		}
		
	}
}



/*
if( ( PIND & ( 1 << PD0 ) ) == 0 )
		{
			PORTB 		= 0xFF;			//alle	LEDs/Relais aus
		}
*/
/*
case 0:
	//lcd_gotoxy(0,0);
	lcd_puts("RGB_LED einschalten   \n");
	lcd_puts("Eingabe mit Taster_3");
	if( ( PIND & ( 1 << PD0 ) ) == 0 )
	{
		PORTB |= ( 1 << PD0 );
	}
	break;
	
case 4:
	//lcd_gotoxy(0,0);
	lcd_puts("RGB_LED ausschalten   \n");
	lcd_puts("Eingabe mit Taster_3");
	if( ( PIND & ( 1 << PD0 ) ) == 0 )
	{
		PORTB &= 0xFE;			//LED (PORTB0)	aus
	}
	break;
*/